import UIKit
import Flutter

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
  override func application(
    _ application: UIApplication,
    didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
  ) -> Bool {
    GeneratedPluginRegistrant.register(with: self)
    
    let controller : FlutterViewController = window?.rootViewController as! FlutterViewController;
    let eventChannel = FlutterEventChannel.init(name: "com.sicilyliu", binaryMessenger: controller.binaryMessenger);
    
    eventChannel.setStreamHandler(SwiftStreamHandler());
    return super.application(application, didFinishLaunchingWithOptions: launchOptions)
  }
}

class SwiftStreamHandler: NSObject, FlutterStreamHandler {
    public func onListen(withArguments arguments: Any?, eventSink events: @escaping FlutterEventSink) -> FlutterError? {
//        events(true) // any generic type or more compex dictionary of [String:Any]

        let dic = NSMutableDictionary.init(dictionary:["code":200, "message":"this is meeeage"]);
        events(dic); // in case of errors
//        events(FlutterEndOfEventStream) // when stream is over
        return nil
    }

    public func onCancel(withArguments arguments: Any?) -> FlutterError? {
        return nil
    }
}

