import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter/cupertino.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    String title = "";
    return MaterialApp(
      title: "lq demo 0519",
      theme: ThemeData(
        primarySwatch:Colors.yellow,
      ),
      home: new EventChannelPage(title),
    );
  }
}



class EventChannelPage extends StatefulWidget {
  String title;
  EventChannelPage(this.title);

  @override
_EventChannelPageState createState() => _EventChannelPageState(title);
}

class _EventChannelPageState extends State<EventChannelPage> {
  String title;
  _EventChannelPageState(this.title);

  String receive = "";

  static const EventChannel _eventChannel = const EventChannel("com.sicilyliu");

  Future<dynamic> nativeMessageListener() async {
    _eventChannel.receiveBroadcastStream().listen((event) {
      int code = event["code"];
      String message = event['message'];
      setState(() {
        receive = "code $code message $message";
        print(receive);
      });
    }, onError: (event) {
      print("error : $event");
    });
  }

  @override
  void initState(){
    super.initState();
    nativeMessageListener();
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return Scaffold(
      appBar: new AppBar(
        backgroundColor: Colors.grey,
        centerTitle:true,
        title: Text(title),
        leading: Container(),
      ),
      body: buildWidget(context),
    );
  }

  buildWidget(BuildContext context) {
    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      mainAxisSize: MainAxisSize.max,
      children: <Widget>[
        Padding(
          padding: EdgeInsets.all(10),
          child: Text(
            "消息：$receive",
            style: TextStyle(
              color: Colors.orange,
              fontSize: 15,
            ),
          ),
        ),
        Padding(
          padding: EdgeInsets.all(15),
          child: FlatButton(
            color: Colors.lightBlue,
            onPressed: () {},
            child: Text(
              'hello',
              style:TextStyle(color:Colors.black, fontSize:20),
            ),
            ),
        ),
        Padding(
          padding: EdgeInsets.all(15),
          child: FlatButton(
            color: Colors.lightBlue,
            onPressed: () {},
            child: Text(
              'getTime',
              style:TextStyle(color:Colors.black, fontSize:20),
            ),
            ),
        ),
        Padding(
          padding: EdgeInsets.all(15),
          child: FlatButton(
            color: Colors.lightBlue,
            onPressed: () {},
            child: Text(
              'battery',
              style:TextStyle(color:Colors.black, fontSize:20),
            ),
            ),
        ),
      ],
    );
  }
}
